//+------------------------------------------------------------------+
//|                                                                  |
//|                                              HowManyOrders.mq4   |
//|                                                  19th Nov 2012   |
//|                                                                  |
//|                                                  First version   |
//|                                                                  |
//| ---------------------------------------------------------------- |
//|                                                                  |
//|                                                  20th Nov 2012   |
//|                                                                  |
//|                                                   Version 1.1    |
//|                                                                  |
//|        Added buffer and recorded number of open orders using an  |
//|              Indicator line in a separate window.                |
//|                                                                  |
//|                                                                  |
//+ ---------------------------------------------------------------- +
#property copyright        "Copyright  2012, RaptorUK"
#property show_inputs

#define VERSION            "1.1"
#define INDICATOR_NAME     "HowManyOrders"

#property indicator_separate_window

#property indicator_buffers 1

#property indicator_color1 White
#property indicator_width1 1
#property indicator_style1 0

extern int MagicNumber = 9876;         // set the magic number for the EA we want to count orders for

extern int Debug_Level = 0;            // Set to a value from 0 to 5, 0 = no debugging (default), 5 = max debugging messages
bool D1, D2, D3, D4, D5;               // debug values, used like this  if(D2) do . . . 

// Indicator buffer
double NumberOfOrders[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
   {
   
   IndicatorShortName(StringConcatenate(MagicNumber, "_", INDICATOR_NAME, " ", VERSION));   
   
   Print(StringConcatenate(INDICATOR_NAME, " ", VERSION), " launched.");   
   
   //---- indicator line
   IndicatorBuffers(1);
   
   SetIndexBuffer(0, NumberOfOrders);
   
   SetIndexStyle(0, DRAW_LINE );
  
   D1=false; D2=false;D3=false;D4=false;D5=false;  // set debug level 
   switch(Debug_Level) {
      case 5: D5=true;
      case 4: D4=true;
      case 3: D3=true;
      case 2: D2=true;
      case 1: D1=true;
      }
   if (D2) Print("Debug status: Debug_Level= ", Debug_Level," (D1= ", D1, " D2= ", D2, " D3= ", D3, " D4=", D4, " D5= ", D5," )");

   return(0);
   }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
   {
   Print("You have been running . . . ", StringConcatenate(INDICATOR_NAME, " ", VERSION), " Terminated... .  .   .      .");   
   
  
   return(0);
   }
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
   int OpenTradesForSymbol = 0;
   
   for(int OrderPosition = OrdersTotal()-1; OrderPosition >= 0 ; OrderPosition--) 
      if ( OrderSelect(OrderPosition, SELECT_BY_POS, MODE_TRADES) &&  OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber ) 
         OpenTradesForSymbol++;

   NumberOfOrders[0] = OpenTradesForSymbol;
   
   return(0);
   } // end of start
//+------------------------------------------------------------------+



